;***************************************************************
;*         aPLib v0.20b  -  the smaller the better :)          *
;*                NASM 16bit assembler depacker                *
;*                                                             *
;*   Copyright (c) 1998-99 by  Jibz  All Rights Reserved   *
;*    -> 16bit    METALBRAIN (metalb@esi.us.es)                *
;***************************************************************

section .text use16

global _aP_depack16_asm

_aP_depack16_asm:
    push   es
    push   ebp
    mov    bp, sp
    pushad

    mov    esi, [bp + 8]      ; C calling convention
    mov    edi, [bp + 12]

    push   bp

    xor    eax, eax           ; convert segm:offs to linear
    xchg   ax, si
    shr    esi, 12
    add    esi, eax

    xor    eax, eax           ; convert segm:offs to linear
    xchg   ax, di
    shr    edi, 12
    add    edi, eax

    push   edi

    cld
    mov    dl, 80h
literal:
    call   getesi
putedi_nexttag:
    call   putedi

nexttag:
    call   getbit
    jnc    literal
    xor    ecx, ecx
    call   getbit
    jnc    codepair
    xor    eax, eax
    call   getbit
    jnc    shortmatch
    mov    al, 10h
getmorebits:
    call   getbit
    adc    al, al
    jnc    getmorebits
    jnz    domatch_with_inc
    jmp    short putedi_nexttag

codepair:
    call   getgamma_no_ecx
    dec    ecx
    loop   normalcodepair, ecx
    mov    eax, ebp
    call   getgamma
    jmp    short domatch

normalcodepair:
    xchg   eax, ecx
    dec    eax
    shl    eax, 8
    call   getesi
    mov    ebp, eax
    call   getgamma
    cmp    eax, 32000
    jae    domatch_with_2inc
    cmp    eax, 1280
    jae    domatch_with_inc
    cmp    eax, BYTE 127
    ja     domatch
domatch_with_2inc:
    inc    ecx
domatch_with_inc:
    inc    ecx

domatch:
    push   esi
    mov    esi, edi
    sub    esi, eax
repmovsb:
    call   getesi
    call   putedi
    loop   repmovsb, ecx
    pop    esi
    jmp    nexttag

shortmatch:
    call   getesi
    shr    eax, 1
    jz     donedepacking
    adc    ecx, ecx
    mov    ebp, eax
    jmp    short domatch_with_2inc

getbit:
    add    dl, dl
    jnz    stillbitsleft
    pushf
    xchg   ax, dx
    call   getesi
    xchg   ax, dx
    popf
    adc    dl, dl
stillbitsleft:
    ret

getgamma:
    xor    ecx, ecx
getgamma_no_ecx:
    inc    cx
getgammaloop:
    call   getbit
    adc    ecx, ecx
    call   getbit
    jc     getgammaloop
    ret

getesi:
    push   esi
    pop    bx
    pop    bx
    ror    bx, 4
    mov    es, bx
    mov    al, [es:si]
    inc    esi
    ret

putedi:
    push   edi
    pop    bx
    pop    bx
    ror    bx, 4
    mov    es, bx
    mov    [es:di], al
    inc    edi
    ret

donedepacking:
    pop    eax

    pop    bp
    sub    edi, eax
    mov    [bp - 4], edi      ; return unpacked length in eax

    popad
    pop    ebp
    pop    es
    ret
